&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

&GLOBAL-DEFINE MD5LIB  c:\gord\pdfinclude\pdfencrypt\md5.exe

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE v_Encrypted         AS LOGICAL NO-UNDO.

DEFINE VARIABLE m_EncryptContent    AS MEMPTR NO-UNDO.
DEFINE VARIABLE m_EncryptKey        AS MEMPTR NO-UNDO.

DEFINE VARIABLE h_pdfencryptlib     AS HANDLE NO-UNDO.

/* This Temp-table is used to store the Hex-to-Character conversion 
   array */
DEFINE TEMP-TABLE hexarray NO-UNDO
   FIELD hex-val   AS CHARACTER
   FIELD chr-val   AS INTEGER
INDEX hex-idx AS PRIMARY
      hex-val
INDEX chr-idx 
      chr-val.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS v_Key v_Editor v_FileName b_Encrypt ~
b_ViewEncryptedFile b_ViewDeEncryptedFile RECT-1 
&Scoped-Define DISPLAYED-OBJECTS v_Key v_Editor v_FileName 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD endecrypt C-Win 
FUNCTION endecrypt RETURNS LOGICAL
  (INPUT BufferPtr    AS MEMPTR,
   INPUT PasswordPtr  AS MEMPTR) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD hex C-Win 
FUNCTION hex RETURNS CHARACTER
  ( INPUT asc-value AS INTEGER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON b_Encrypt 
     LABEL "Encrypt" 
     SIZE 15 BY 1.14.

DEFINE BUTTON b_ViewDeEncryptedFile 
     LABEL "Click Here to view the Encrypted File Decrypted" 
     SIZE 52 BY 1.14.

DEFINE BUTTON b_ViewEncryptedFile 
     LABEL "Click Here to view the Encrypted File" 
     SIZE 52 BY 1.14.

DEFINE VARIABLE v_Editor AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL LARGE
     SIZE 53 BY 5.24 NO-UNDO.

DEFINE VARIABLE v_FileName AS CHARACTER FORMAT "X(256)":U INITIAL "c:~\temp~\encrypt.txt" 
     LABEL "Output FileName" 
     VIEW-AS FILL-IN 
     SIZE 36 BY 1 NO-UNDO.

DEFINE VARIABLE v_Key AS CHARACTER FORMAT "X(256)":U 
     LABEL "Enter your alphanumberic key" 
     VIEW-AS FILL-IN 
     SIZE 24 BY 1 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE .5 BY 15.95.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     v_Key AT ROW 3.86 COL 45 COLON-ALIGNED
     v_Editor AT ROW 6.48 COL 18 NO-LABEL
     v_FileName AT ROW 13.14 COL 33 COLON-ALIGNED
     b_Encrypt AT ROW 14.33 COL 35
     b_ViewEncryptedFile AT ROW 16.24 COL 19
     b_ViewDeEncryptedFile AT ROW 18.14 COL 19
     RECT-1 AT ROW 3.62 COL 14
     "This sample illustrates how to encrypt/decrypt some text using the ARC4" VIEW-AS TEXT
          SIZE 69 BY .62 AT ROW 1.24 COL 2
     "Algorithm with a MD5-hashed key." VIEW-AS TEXT
          SIZE 33 BY .62 AT ROW 1.95 COL 2
     "Step 1:" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 4.1 COL 4
          FGCOLOR 9 
     "Step 2:" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 5.52 COL 4
          FGCOLOR 9 
     "Enter some text in the editor below" VIEW-AS TEXT
          SIZE 34 BY .62 AT ROW 5.52 COL 18
     "Step 3:" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 12.19 COL 4
          FGCOLOR 9 
     "Enter the output filename and press the 'Encrypt' button." VIEW-AS TEXT
          SIZE 55 BY .62 AT ROW 12.19 COL 18
     "Step 4:" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 16 COL 4
          FGCOLOR 9 
     "Step 5:" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 17.91 COL 4
          FGCOLOR 9 
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80 BY 19.19.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Illustrate Encryption"
         HEIGHT             = 19.19
         WIDTH              = 80
         MAX-HEIGHT         = 19.19
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 19.19
         VIRTUAL-WIDTH      = 80
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
ASSIGN 
       v_Editor:RETURN-INSERTED IN FRAME DEFAULT-FRAME  = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Illustrate Encryption */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Illustrate Encryption */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b_Encrypt
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b_Encrypt C-Win
ON CHOOSE OF b_Encrypt IN FRAME DEFAULT-FRAME /* Encrypt */
DO:
  RUN DoEncryptionProcess.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b_ViewDeEncryptedFile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b_ViewDeEncryptedFile C-Win
ON CHOOSE OF b_ViewDeEncryptedFile IN FRAME DEFAULT-FRAME /* Click Here to view the Encrypted File Decrypted */
DO:
  DEFINE VARIABLE m_EncryptText AS MEMPTR NO-UNDO.

  IF NOT v_Encrypted THEN DO:
    MESSAGE "The encrypted file has not been created yet!"
            VIEW-AS ALERT-BOX ERROR.
    RETURN.
  END.

  IF SEARCH(v_FileName) = ? THEN DO:
    MESSAGE "Cannot find original Encrypted output file!" 
            VIEW-AS ALERT-BOX ERROR.
    RETURN.
  END.

  FILE-INFO:FILE-NAME = v_FileName NO-ERROR.
  IF ERROR-STATUS:ERROR THEN DO:
    MESSAGE "ERROR:" ERROR-STATUS:GET-NUMBER(1) VIEW-AS ALERT-BOX.
    RETURN.
  END.

  SET-SIZE(m_EncryptText) = FILE-INFO:FILE-SIZE.

  INPUT FROM VALUE(v_FileName) BINARY NO-CONVERT.
    IMPORT m_EncryptText.
  INPUT CLOSE.

  RUN EncryptText (INPUT  m_EncryptKey,
                   INPUT  m_EncryptText,
                   OUTPUT m_EncryptContent).

  SET-SIZE(m_EncryptText) = 0.

  OUTPUT TO VALUE(v_FileName).
    EXPORT m_EncryptContent.
  OUTPUT CLOSE.

  OS-COMMAND SILENT VALUE("write " + v_FileName).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b_ViewEncryptedFile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b_ViewEncryptedFile C-Win
ON CHOOSE OF b_ViewEncryptedFile IN FRAME DEFAULT-FRAME /* Click Here to view the Encrypted File */
DO:
  IF NOT v_Encrypted THEN DO:
    MESSAGE "You have not encrypted your text yet!"
            VIEW-AS ALERT-BOX ERROR.
    RETURN.
  END.

  IF SEARCH(v_FileName) = ? THEN DO:
    MESSAGE "Cannot find output file!" VIEW-AS ALERT-BOX ERROR.
    RETURN.
  END.

  OS-COMMAND SILENT VALUE("write " + v_FileName).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  
  RUN LoadHexArray.
  RUN pdfencryptlib.p PERSISTENT SET h_pdfencryptlib.

  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

SET-SIZE(m_EncryptKey)     = 0.
SET-SIZE(m_EncryptContent) = 0.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DoEncryptionProcess C-Win 
PROCEDURE DoEncryptionProcess :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE m_Text  AS MEMPTR NO-UNDO.

  ASSIGN FRAME {&FRAME-NAME} 
         v_Key
         v_Editor
         v_FileName.

  IF v_Key = "" THEN DO:
    MESSAGE "You must enter a non-blank key!" VIEW-AS ALERT-BOX ERROR.
    APPLY "ENTRY" TO v_Key.
    RETURN.
  END.

  IF v_Editor = "" THEN DO:
    MESSAGE "You must enter some text into the Editor!" VIEW-AS ALERT-BOX ERROR.
    APPLY "ENTRY" TO v_Editor.
    RETURN.
  END.

  IF v_FileName = "" THEN DO:
    MESSAGE "You must enter a valid File Name!" VIEW-AS ALERT-BOX ERROR.
    APPLY "ENTRY" TO v_FileName.
    RETURN.
  END.


  SET-SIZE(m_Text) = LENGTH(v_Editor).
  PUT-STRING(m_Text,1, LENGTH(v_Editor)) = v_Editor.

  RUN GetMD5Key   (INPUT v_Key, OUTPUT m_EncryptKey).
  RUN EncryptText (INPUT  m_EncryptKey,
                   INPUT  m_Text,
                   OUTPUT m_EncryptContent).

  SET-SIZE(m_Text) = 0.

  OUTPUT TO VALUE(v_FileName).
    EXPORT m_EncryptContent.
  OUTPUT CLOSE.

  v_Encrypted = TRUE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY v_Key v_Editor v_FileName 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE v_Key v_Editor v_FileName b_Encrypt b_ViewEncryptedFile 
         b_ViewDeEncryptedFile RECT-1 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE EncryptText C-Win 
PROCEDURE EncryptText :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  DEFINE INPUT  PARAMETER p_EncryptKey     AS MEMPTR    NO-UNDO.
  DEFINE INPUT  PARAMETER p_Original       AS MEMPTR    NO-UNDO.
  DEFINE OUTPUT PARAMETER p_Encrypted      AS MEMPTR    NO-UNDO.

  DEFINE VARIABLE L_Hash    AS CHARACTER NO-UNDO.
  DEFINE VARIABLE L_NewKey  AS MEMPTR NO-UNDO.
  DEFINE VARIABLE L_Copy    AS MEMPTR NO-UNDO.
  DEFINE VARIABLE L_Keyptr  AS MEMPTR NO-UNDO.
  DEFINE VARIABLE L_Loop    AS INTEGER NO-UNDO.
  DEFINE VARIABLE L_Byte    AS INTEGER NO-UNDO.

  DEFINE VARIABLE L_Content   AS MEMPTR NO-UNDO.

  SET-SIZE(L_KeyPtr) = 0.
  SET-SIZE(L_Content) = 0.
  SET-SIZE(L_KeyPtr) = 10.
  SET-SIZE(L_Content) = GET-SIZE(p_Original).
  
  L_Content = p_Original.

  endecrypt(L_Content, p_Encryptkey).

  p_Encrypted = L_Content.

  SET-SIZE(L_KeyPtr) = 0.
  SET-SIZE(L_Content) = 0.
  SET-SIZE(L_KeyPtr) = 0.
  SET-SIZE(L_Content) = 0.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetEncryptKey C-Win 
PROCEDURE GetEncryptKey :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetMD5Key C-Win 
PROCEDURE GetMD5Key :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER p_Key           AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER p_EncryptedKey  AS MEMPTR NO-UNDO.

  DEFINE VARIABLE L_Hash      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE L_TxtFile   AS CHARACTER NO-UNDO.
  DEFINE VARIABLE L_md5File   AS CHARACTER NO-UNDO.

  DEFINE VARIABLE L_Loop  AS INTEGER NO-UNDO.
  DEFINE VARIABLE L_Byte  AS INTEGER NO-UNDO.

  ASSIGN L_TxtFile = SESSION:TEMP-DIR + "encrypt-key.txt"
         L_md5File = SESSION:TEMP-DIR + "encrypt-key.md5".

  /* Then run the md5 hash against that 10 byte key - orig + obj + gen */
  OUTPUT TO VALUE(l_TxtFile).
    PUT UNFORMATTED p_Key SKIP.
  OUTPUT CLOSE.

  IF OPSYS = "UNIX" THEN DO:
    INPUT THROUGH VALUE("{&MD5LIB} " + L_TxtFile) NO-ECHO.
      IMPORT L_Hash.
    INPUT CLOSE.
  END.
  
  ELSE DO:
    OS-COMMAND SILENT VALUE("{&MD5LIB} " + L_TxtFile + " > " + L_md5File) NO-ECHO.

    INPUT FROM VALUE(L_md5File) NO-ECHO NO-CONVERT.
      IMPORT L_HasH.
    INPUT CLOSE.

    OS-DELETE VALUE(L_md5File).
  END.

  OS-DELETE VALUE(L_TxtFile).

  SET-SIZE(p_EncryptedKey) = 0.
  SET-SIZE(p_EncryptedKey) = 10.
  /* Now take the first 10 bytes (could be more or less) of the resulting md5 
     hash as the encryption key */
  L_Byte = 1.
  DO L_loop = 1 TO 20 BY 2:
    IF SUBSTR(L_Hash,L_loop,2) = "00" THEN
      PUT-BYTE(p_EncryptedKey,L_Byte) = 0.
    ELSE DO:
      FIND FIRST HexArray WHERE HexArray.Hex-Val = SUBSTR(L_Hash,L_Loop,2).
      PUT-BYTE(p_EncryptedKey,L_Byte) = ASC(CHR(HexArray.chr-val)).
    END.

    L_Byte = L_Byte + 1.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LoadHexArray C-Win 
PROCEDURE LoadHexArray :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE vHexLoop AS INTEGER NO-UNDO.

  DO vHexLoop = 0 TO 255:
    CREATE HexArray.
    ASSIGN HexArray.hex-val = hex(vHexLoop)
           HexArray.chr-val = vHexLoop.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION endecrypt C-Win 
FUNCTION endecrypt RETURNS LOGICAL
  (INPUT BufferPtr    AS MEMPTR,
   INPUT PasswordPtr  AS MEMPTR):

  RUN endecrypt IN h_pdfencryptlib 
              (INPUT GET-POINTER-VALUE(BufferPtr), 
               INPUT GET-SIZE(BufferPtr),
               INPUT GET-POINTER-VALUE(PasswordPtr),
               INPUT GET-SIZE(PasswordPtr) ) .
  
  RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION hex C-Win 
FUNCTION hex RETURNS CHARACTER
  ( INPUT asc-value AS INTEGER ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  DEF VAR j AS INT  NO-UNDO.
  DEF VAR h AS CHAR NO-UNDO.

  DO WHILE TRUE:
    j = asc-value MODULO 16.
    h = (IF j < 10 THEN STRING(j) ELSE CHR(ASC("A") + j - 10)) + h.
    IF asc-value < 16 THEN LEAVE.
    asc-value = (asc-value - j) / 16.
  END.

  IF LENGTH(h) = 1 THEN
    h = "0" + h.

  RETURN h.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

